<TeXmacs|1.0>

<style|letter>

<\body>
  LuSe Syntax Checker

  <\enumerate>
    <item>Description

    LuSe Syntax Checker is based on the BNF definition of Prolog syntax.

    program ::= sentence { "." sentences}

    sentence ::= head ":-" body "." \| head "."

    body ::= goal

    goal ::= compound_term \| term " " "is" \ " " expr

    goal ::= term infix_operator2 term \| term infix_operator3 term

    goals ::= goal \| goal {"," goals}

    compound_term ::= atom "(" terms ")" \| list

    compound_terms ::= compound_term \| compound_term {"," compound_terms}

    expr ::= simpleExpr \| simple_expr infix_operator simple_expr

    simple_expr ::= term \| "(" expr ")"

    term ::= constant \| variable \| "_" \| compound_term

    terms ::= term \| term {"," terms}

    infix_operator ::= "+" "-" "*" "/" "mod"

    infix_operator2 ::= "==" \|"=" \|"=<inactive|<hybrid|>>="\ 

    infix_operator3 ::= "=\<less\>" \|"\<less\>" \|"\<gtr\>"\| "\<gtr\>="
    \|"@=" \|"=:="

    list ::= "[" "]" \| "[" terms "]" \| "[" terms \ "\|" term "]"

    atom ::= lowercaseChar \| nameChars

    constant ::= integer \| atom

    integer ::= digit \| digits

    digit ::= "0" ...\| "9"

    variable ::= uppercaseChar \| uppercaseChar nameChars

    lowercaseChar ::= "a" ...\| "z"\ 

    uppercaseChar ::= "A" ...\| "Z"

    <item>How to use the LuSe Syntax Checker

    the syntax Checker provides following functionalities:

    <\expand|itemize-minus>
      <item>check_program_syntax(+Program, -Clauses, -ErrorList) reads a
      Prolog program that has several clauses and returns a list of corrected
      clauses and a list of errors. The error list has this form:
      [1-[error([0], missing())), error([1, 0], missing(]))]]. The number 1
      followed by the list of errors indicates that the errors belong to the
      first clause.
    </expand>

    <\expand|itemize-minus>
      <item>check_clause_syntax(+String, -Term, -Errors) reads just one
      clause as input and returns a corrected term with a list of errors. In
      this error list we will not have the number in front of error list
      because in this case we just have one clause.

      <item>check_query_syntax(+String,-Term,-Errors) does the same as
      check_clause_syntax but just be applied for a query.
    </expand>

    <\expand|itemize-dot>
      \;

      \;
    </expand>
  </enumerate>

  \;

  \;
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
    <associate|language|english>
  </collection>
</initial>
