% Author: Nguyen-Thinh Le
% Modified by: $Id: listUtil.pl,v 1.3 2004/04/13 14:52:58 nthinh Exp $

:-module(listUtil,[replace_n_element/4, remove_n_element/3,n_tes/3, seperateListByX/3, remove_last_element/2, remove_first_element/2  ]).

%= replace n.th element of a list
%= private replace_n_element(+N,+List,+Value,-NewList)
replace_n_element(1,[_|Rest],Value,[Value|Rest]).
replace_n_element(N,[X|Rest],Value,[X|NewRest]):-
	NewN is N-1,
	replace_n_element(NewN, Rest,Value,NewRest).


%= remove n.th element of a list
%= private remove_n_element(+N,+List,-NewList)
remove_n_element(1,[_|Rest],Rest).
remove_n_element(N,[X|Rest],[X|NewRest]):-
	NewN is N-1,
	remove_n_element(NewN, Rest,NewRest).

      
	

% get n.th element from list
% (b) das N-te "passende" Element aus einer Liste
n_tes(1,[X|_],X).
n_tes(N,[_|Rest],Y):-
	N1 is N-1,
	n_tes(N1,Rest,Y).

% seperateListByX(+List,+X,-ResultList)
% this predicate will look for the element X in the List, 
% then move a list of the first the element to X (without X) to ResultList.
% X will be removed and the rest will be recurvively processed.


seperateListByX(List,X,Result):-seperateListByX(List,X,[],Result).
seperateListByX([Y|Rest],X,Acc, Result):-
	Y\=X,
	seperateListByX(Rest,X,[Y|Acc],Result).
seperateListByX([X|Rest],X,Acc,[AccRev|NewRest]):-
	reverse(Acc,AccRev),
	seperateListByX(Rest,X,[],NewRest).
%seperateListByX([],_,Acc,[AccRev]):-reverse(Acc,AccRev).
seperateListByX([X],X,Acc,[AccRev]):-reverse(Acc,AccRev).
seperateListByX([Y],X,Acc,[AccRev]):-reverse([Y|Acc],AccRev).

% remove the last element of a list
remove_last_element(List,NewList):-
	length(List,N),
	remove_n_element(N,List,NewList).

% remove the first element of a list
remove_first_element([_|Rest],Rest).

add_at_end(El, List-Tail, List-Tail2):-
	Tail=[El|Tail2],!.
add_at_end(X,List-[X|NewTail], List-NewTail).

	
