% Created by Nguyen-Thinh Le.
% Modified: $Id: logging.pl,v 1.6 2004/03/30 06:59:37 walters Exp $ 
:- module(logging,[set_logfile/1,create_logfile/1,logging/3, set_logging_for/2, set_logging_forall/1]).

:- dynamic logfile/1.
:- dynamic logging/1.
:- dynamic logging_for/2.
:- dynamic logging_forall/0.

set_logfile(Dom):-
	create_logfile(Dom).
%set_logging(X):-
	%retractall(logging(_)),
	%assert(logging(X)).

set_logging_for(Module,Bool):-
	retractall(logging_for(Module,_)), 
	assert(logging_for(Module,Bool)).


set_logging_forall(true):- assert(logging_forall).
set_logging_forall(false):- retractall(logging_forall).

check_logging_off(ModuleName) :- logging_for(ModuleName, false).


create_logfile(Dom):-
	get_time(Time),
	convert_time(Time, Year,Month,Day, Hour, Minute, Second, Millis),
	string_concat(Year,Month,YearMonth),
	string_concat(YearMonth,Day, Date),
	%string_concat(Hour,Minute,HourMinute),
	%string_concat(HourMinute,Second,HourMinuteSecond),
	%string_concat(HourMinuteSecond,MilliSeconds,TimeString),
	%string_concat(DateString,TimeString,DateTime),
	string_concat(Dom,Date,DomDate),
	string_concat(DomDate,'.txt',LogFile),
	retractall(logfile(_)),
	assert(logfile(LogFile)),
	open(LogFile,append, LogStream,[close_on_abort(true)]),
	format(LogStream,'Begin logging at ~w h ~w min ~w sec ~w millis',[Hour,Minute,Second,Millis]),
	close(LogStream),
	debug(logging,'<create_logfile>current logfile is ~w',[LogFile]).


% write logging information if: A) the particular module is specificly chosen to be logged or B) it is not chosen not to be logged and default logging is on. Otherwise succeed without logging output.

logging(ModuleName,Text,Vars):-

	 (   logging_for(ModuleName, true);(logging_forall, not(check_logging_off(ModuleName))))->

	(  logfile(LogFile),
	   open(LogFile,append, LogStream,[close_on_abort(true)]),
           nl(LogStream),
	   format(LogStream,'<~w>',[ModuleName]),
	   format(LogStream,Text,Vars),
	   close(LogStream)
	); true.












