:- op(900,xfx,::).

listify(X,lst(X)).

map :: [[T1|L]:A,lst(T1)|L1]:lst(A) :- maplist(listify,L,L1).
curry :: [[A|L]:B,A]:L:B.
filter :: [[A]:bool, lst(A)]:lst(A).
always :: [A]:(_:A).
(+) :: [num,num]:num.
if :: [bool,A,A]:A.
(=) :: [num,num]:bool.
(<) :: [num,num]:bool.
(>) :: [num,num]:bool.
even :: num:bool.
odd :: num:bool.
'null?' :: [lst(_)]:bool.
cons :: [A,lst(A)]:lst(A).
car :: [lst(A)]:lst(A).
cdr :: [lst(A)]:lst(A).
append :: [lst(A),lst(A)]:lst(A).
X :: num :- number(X).
[] :: lst(_).
quote([])::lst(_).
quote([A|_]) :: lst(Type) :- (A::Type).
_ :: anything.
/*
Probleme:
- Special Forms: define, lambda, cond, let
  dabei: mglichst problemlos zu parsen, Hilfestellung
  durch Klammern mglichst gut verwerten.
- Variablen
- quotes etc.: '(affe tiger 2.3) (list 'affe 'tiger)
- Proper vs. improper lists
  sowohl
    cons::[A,lst(A)]:lst(A)
  als auch
    cons::[A,B]:improper_list(A,B) :- B\=lst(_), B\=improper_list(_,_)
    cons::[A,improper_list(A,B)]:B
    car::[improper_list(A,B)]:A
  und dann: sowohl
    cdr::[improper_list(A,B)]:B als auch
    cdr::[improper_list(A,B)]:improper_list(A,B) ???
  mglich: Verallgemeinerung von lst und improper_list zu
  glst(A,B) mit lst(A)\equiv glst(A,null)
  und null::[glst(A,null)]:bool ???

Testflle:
(curry (+ 1)) --> (curry + 1)

define my-reverse (a b)
 if null a
    b
    my-reverse (cdr a) (cons (car a) (cdr b))
with-vars([a::A,b::B,my-reverse::[A,B]:C],
--> my-reverse :: [lst(A),lst(A)]:lst(A)
Problem: der unbekannte Typ von a und b fhrt dazu, dass
(cons a car) gelesen wird (a als Liste von Funktionen)   
*/
findtype(LocalVars,A,A::B):-
	member(A::B,LocalVars),!.
findtype(_,A,A::B):-A::B.
gettype(_::A,A).
getexpr(A::_,A).
parse(L,Result):-parse([],L,Result).
parse(LocalVars,L,Result):-
	maplist(findtype(LocalVars),L,ResList),
	reduce(ResList,Result).
reduce(A,B):-reduce0(A,A1),reduce(A1,B).
reduce(A,A).
reduce0(A,B):-
	append(A1,A2,A),
	reduce1(A2,A3),
	append(A1,A3,B).
% unschn: wir unterscheiden zwischen Funktionen und nicht-Funktionen
% um nicht endlose Reihen von
% a, (a), ((a)), (((a))), ((((a))))
% zu produzieren.
reduce1([Op|Rest],[Result|Rest1]):-
	Op=(OpExpr::OpType),
	not(var(OpType)),
	OpType=ArgTypes:ResType,
	append(Args,Rest1,Rest),
	maplist(gettype,Args,ArgTypes),
	maplist(getexpr,Args,ArgExprs),
	Result=([OpExpr|ArgExprs]::ResType).

test(1):-parse([map,curry,+,1,quote([1,2,3])],_::lst(num)).
test(1):-parse([a::_,b::_],[cons,car,a,b]).
test(2):-parse([a::A,b::B,my-reverse::[A,B]:C],
	       [if,'null?',a,b,my-reverse,cdr,a,cons,car,a,cdr,b],
	       _).

